#!/bin/sh

TARGET=$1
PREFIX=$2
SWPKG=$3

SWURL="ftp://sources.redhat.com/pub/newlib/"
SW="newlib-2.1.0.tar.gz"

if test -z "$PREFIX"; then
    echo "Crosscompiler install script."
    echo "To install the target toolchain type the following command:"
    echo $0 " <TargetAch> <InstallDir> <SoftwarePackage>"
    echo
    echo "The software package can be one of these:"
    echo "[all] binutils minimal-gcc uclibc gcc gdb clean"
    echo "If the parameter is missing, we're taking [all] as default."
    exit 0
fi

echo "We're going to install the newlib in this directory: " $PREFIX
echo "for " $TARGET " Architecture"
echo

# the different paths
FILEDIR=`pwd`
SRCDIR=$PREFIX/src
BUILDDIR=$SRCDIR/build

# The tar archievs
LIBC=`ls $DOWNLOADDIR/$SW`

if [[ $LIBC = $DOWNLOADDIR/$SW ]];
then
    echo $LIBC " already found"
else
    echo cd $DOWNLOADDIR
    cd $DOWNLOADDIR || exit 1

    echo wget -nd "${SWURL}${SW}"
    wget -nd "${SWURL}${SW}" || exit 1

    LIBC=$DOWNLOADDIR/$SW
fi


# 0. creating the directory
echo mkdir -p $SRCDIR
mkdir -p $SRCDIR || exit 1


# 1. setting the path
PATH=$PREFIX/bin:$PATH


# 2. Do it ...
case $SWPKG in

    libc)

    echo tar -xz -C $SRCDIR -f $LIBC
    tar -xz -C $SRCDIR -f $LIBC || exit 1

    echo mkdir -p $BUILDDIR/newlib
    mkdir -p $BUILDDIR/newlib || exit 1

    echo cd $BUILDDIR/newlib
    cd $BUILDDIR/newlib || exit 1

    LIBCSRCDIR=`ls -d $SRCDIR/newlib*`

    echo $LIBCSRCDIR/configure  --target=$TARGET --prefix=$PREFIX
    $LIBCSRCDIR/configure --target=$TARGET --prefix=$PREFIX || exit 1

    echo make
    make -j 3 || exit 1

    echo make install
    make install || exit 1

    echo rm -rf $BUILDDIR/newlib $LIBCSRCDIR
    rm -rf $BUILDDIR/newlib $LIBCSRCDIR || exit 1

    cd $FILEDIR || exit 1

    ;;

esac


exit 0
