#!/bin/sh

TARGET=$1
PREFIX=$2
SWPKG=$3

case $SWPKG in

    mpc)

      SWURL="http://www.multiprecision.org/mpc/download/"
      SW="mpc-0.9.tar.gz"
      ;;

esac

if test -z "$PREFIX"; then
    echo "Crosscompiler install script."
    echo "To install the target toolchain type the following command:"
    echo $0 " <TargetAch> <InstallDir> <SoftwarePackage>"
    echo
    echo "The software package can be one of these:"
    echo "[all] binutils minimal-gcc uclibc gcc gdb clean"
    echo "If the parameter is missing, we're taking [all] as default."
    exit 0
fi

echo "We're going to install the mpc in this directory: " $PREFIX
echo "for " $TARGET " Architecture"
echo

# the different paths
FILEDIR=`pwd`
SRCDIR=$PREFIX/src
BUILDDIR=$SRCDIR/build

# The tar archievs
MPC=`ls $DOWNLOADDIR/$SW`

if [[ $MPC = $DOWNLOADDIR/$SW ]];
then
    echo $MPC " already found"
else
    echo cd $DOWNLOADDIR
    cd $DOWNLOADDIR || exit 1

    echo wget -c -nd "${SWURL}${SW}"
    wget -c -nd "${SWURL}${SW}" || exit 1

    MPC=$DOWNLOADDIR/$SW
fi

# 0. creating the directory
echo mkdir -p $SRCDIR
mkdir -p $SRCDIR || exit 1


# 1. setting the path
PATH=$PREFIX/bin:$PATH


# 2. mpc
case $SWPKG in

    mpc)

    echo tar -xz -C $SRCDIR -f $MPC
    tar -xz -C $SRCDIR -f $MPC || exit 1

    echo mkdir -p $BUILDDIR/mpc
    mkdir -p $BUILDDIR/mpc || exit 1

    echo cd $BUILDDIR/mpc
    cd $BUILDDIR/mpc || exit 1

    MPCSRCDIR=`ls -d $SRCDIR/mpc*`

    echo $MPCSRCDIR/configure --build=x86_64-unknown-linux-gnu --host=i686-w64-mingw32 --prefix=$PREFIX --with-gmp=$PREFIX
    $MPCSRCDIR/configure --build=x86_64-unknown-linux-gnu --host=i686-w64-mingw32 --prefix=$PREFIX --with-gmp=$PREFIX || exit 1

    echo make -j 3
    make -j 3 || exit 1

    echo make install 
    make install || exit 1

    echo rm -rf $BUILDDIR/mpc $MPCSRCDIR
    rm -rf $BUILDDIR/mpc $MPCSRCDIR || exit 1

    cd $FILEDIR || exit 1

    ;;

esac

exit 0
