#!/bin/sh

TARGET=$1
PREFIX=$2
SWPKG=$3

case $SWPKG in

    mpfr)

      SWURL="http://www.mpfr.org/mpfr-current/"
      SW="mpfr-3.1.2.tar.bz2"
      ;;

esac

if test -z "$PREFIX"; then
    echo "Crosscompiler install script."
    echo "To install the target toolchain type the following command:"
    echo $0 " <TargetAch> <InstallDir> <SoftwarePackage>"
    echo
    echo "The software package can be one of these:"
    echo "[all] binutils minimal-gcc uclibc gcc gdb clean"
    echo "If the parameter is missing, we're taking [all] as default."
    exit 0
fi

echo "We're going to install the mpfr in this directory: " $PREFIX
echo "for " $TARGET " Architecture"
echo

# the different paths
FILEDIR=`pwd`
SRCDIR=$PREFIX/src
BUILDDIR=$SRCDIR/build

# The tar archievs
MPFR=`ls $DOWNLOADDIR/$SW`

if [[ $MPFR = $DOWNLOADDIR/$SW ]];
then
    echo $MPFR " already found"
else
    echo cd $DOWNLOADDIR
    cd $DOWNLOADDIR || exit 1

    echo wget -c -nd "${SWURL}${SW}"
    wget -c -nd "${SWURL}${SW}" || exit 1

    MPFR=$DOWNLOADDIR/$SW
fi

# 0. creating the directory
echo mkdir -p $SRCDIR
mkdir -p $SRCDIR || exit 1


# 1. setting the path
PATH=$PREFIX/bin:$PATH


# 2. mpfr
case $SWPKG in

    mpfr)

    echo tar -xj -C $SRCDIR -f $MPFR
    tar -xj -C $SRCDIR -f $MPFR || exit 1

    echo mkdir -p $BUILDDIR/mpfr
    mkdir -p $BUILDDIR/mpfr || exit 1

    echo cd $BUILDDIR/mpfr
    cd $BUILDDIR/mpfr || exit 1

    MPFRSRCDIR=`ls -d $SRCDIR/mpfr*`

    echo $MPFRSRCDIR/configure --build=x86_64-unknown-linux-gnu --host=i686-w64-mingw32 --prefix=$PREFIX --with-gmp=$PREFIX
    $MPFRSRCDIR/configure --build=x86_64-unknown-linux-gnu --host=i686-w64-mingw32 --prefix=$PREFIX --with-gmp=$PREFIX || exit 1

    echo make -j 3
    make -j 3 || exit 1

    echo make install 
    make install || exit 1

    echo rm -rf $BUILDDIR/mpfr $MPFRSRCDIR
    rm -rf $BUILDDIR/mpfr $MPFRSRCDIR || exit 1

    cd $FILEDIR || exit 1

    ;;

esac

exit 0
