#!/bin/sh

TARGET=$1
PREFIX=$2
SWPKG=$3

case $SWPKG in

    canadian-libusb)

      SWURL="http://downloads.sourceforge.net/project/libusb-win32/libusb-win32-releases/1.2.6.0/"
      SW="libusb-win32-bin-1.2.6.0.zip"
      ;;

esac

if test -z "$PREFIX"; then
    echo "Crosscompiler install script."
    echo "To install the target toolchain type the following command:"
    echo $0 " <TargetAch> <InstallDir> <SoftwarePackage>"
    echo
    echo "The software package can be one of these:"
    echo "[all] binutils minimal-gcc uclibc gcc gdb make clean"
    echo "If the parameter is missing, we're taking [all] as default."
    exit 0
fi

echo "We're going to install libusb in this directory: " $PREFIX
echo "for " $TARGET " Architecture"
echo

# the different paths
FILEDIR=`pwd`
SRCDIR=$PREFIX/src
BUILDDIR=$SRCDIR/build

# The tar archievs
LIBUSB=`ls $DOWNLOADDIR/$SW`

if [[ $LIBUSB = $DOWNLOADDIR/$SW ]];
then
    echo $LIBUSB " already found"
else
    echo cd $DOWNLOADDIR
    cd $DOWNLOADDIR || exit 1

    echo wget -c -nd "${SWURL}${SW}"
    wget -c -nd "${SWURL}${SW}" || exit 1

    LIBUSB=$DOWNLOADDIR/$SW
fi

# 0. creating the directory
echo mkdir -p $SRCDIR
mkdir -p $SRCDIR || exit 1


# 1. setting the path
PATH=$PREFIX/bin:$PATH


# 2. libusb
case $SWPKG in

    canadian-libusb)

    echo unzip -d $SRCDIR $LIBUSB
    unzip -d $SRCDIR $LIBUSB || exit 1

    LIBUSBSRCDIR=`ls -d $SRCDIR/libusb*`

    echo cp $LIBUSBSRCDIR/bin/x86/libusb0_x86.dll $PREFIX/bin/libusb0.dll
    cp $LIBUSBSRCDIR/bin/x86/libusb0_x86.dll $PREFIX/bin/libusb0.dll || exit 1

    cd $FILEDIR || exit 1

    ;;

esac

exit 0
