#!/bin/sh

TARGET=$1
PREFIX=$2
SWPKG=$3

SWURL="http://ftp.gnu.org/gnu/make/"
SW="make-3.82.tar.bz2"

if test -z "$PREFIX"; then
    echo "Crosscompiler install script."
    echo "To install the target toolchain type the following command:"
    echo $0 " <TargetAch> <InstallDir> <SoftwarePackage>"
    echo
    echo "The software package can be one of these:"
    echo "[all] binutils minimal-gcc uclibc gcc gdb make clean"
    echo "If the parameter is missing, we're taking [all] as default."
    exit 0
fi

echo "We're going to install make in this directory: " $PREFIX
echo "for " $TARGET " Architecture"
echo

# the different paths
FILEDIR=`pwd`
SRCDIR=$PREFIX/src
BUILDDIR=$SRCDIR/build

# The tar archievs
MAKE=`ls $DOWNLOADDIR/$SW`

if [[ $MAKE = $DOWNLOADDIR/$SW ]];
then
    echo $MAKE " already found"
else
    echo cd $DOWNLOADDIR
    cd $DOWNLOADDIR || exit 1

    echo wget -c -nd "${SWURL}${SW}"
    wget -c -nd "${SWURL}${SW}" || exit 1

    MAKE=$DOWNLOADDIR/$SW
fi

# 0. creating the directory
echo mkdir -p $SRCDIR
mkdir -p $SRCDIR || exit 1


# 1. setting the path
PATH=$PREFIX/bin:$PATH


# 2. make
case $SWPKG in

    make)

    echo tar -xj -C $SRCDIR -f $MAKE
    tar -xj -C $SRCDIR -f $MAKE || exit 1

    echo mkdir -p $BUILDDIR/make
    mkdir -p $BUILDDIR/make || exit 1

    echo cd $BUILDDIR/make
    cd $BUILDDIR/make || exit 1

    MAKESRCDIR=`ls -d $SRCDIR/make*`

    echo $MAKESRCDIR/configure --build=x86_64-unknown-linux-gnu --host=$HOST --prefix=$PREFIX
    $MAKESRCDIR/configure --build=x86_64-unknown-linux-gnu --host=$HOST --prefix=$PREFIX || exit 1

    echo make -j 8
    make -j 8 || exit 1

    echo make install 
    make install || exit 1

    echo rm -rf $BUILDDIR/make $MAKESRCDIR
    rm -rf $BUILDDIR/make $MAKESRCDIR || exit 1

    cd $FILEDIR || exit 1

    ;;

    canadian-make)

    echo tar -xj -C $SRCDIR -f $MAKE
    tar -xj -C $SRCDIR -f $MAKE || exit 1

    echo mkdir -p $BUILDDIR/make
    mkdir -p $BUILDDIR/make || exit 1

    echo cd $BUILDDIR/make
    cd $BUILDDIR/make || exit 1

    MAKESRCDIR=`ls -d $SRCDIR/make*`

    echo $MAKESRCDIR/configure --build=x86_64-unknown-linux-gnu --host=i686-w64-mingw32 --prefix=$PREFIX
    $MAKESRCDIR/configure --build=x86_64-unknown-linux-gnu --host=i686-w64-mingw32 --prefix=$PREFIX || exit 1

    echo make -j 8
    make -j 8 || exit 1

    echo make install 
    make install || exit 1

    echo rm -rf $BUILDDIR/make $MAKESRCDIR
    rm -rf $BUILDDIR/make $MAKESRCDIR || exit 1

    cd $FILEDIR || exit 1

    ;;

esac

exit 0
